

def loadFasta(filename):

    f=open(filename)
    pname=""
    pseq=""
    prots={}

    for row in f:
        if row[0] == '>':
            if pname:
                prots[pname] = pseq
                pname = ""
                pseq = ""
            pname = row[1:].rstrip()
        else:
            pseq += row.rstrip()

    if pname:
        prots[pname] = pseq

    f.close()

    return prots


def findPatterns(prots, k):
    
    patterns={}
    
    for seq in prots.values():
        for i in range(0,len(seq)-k+1):
            pat=seq[i:i+k]
            if len(pat) < k:
                break
            if patterns.has_key(pat):
                patterns[pat] += 1
            else:
                patterns[pat] = 1

    return patterns


def filterPatterns(patterns, h):

    filtpatterns={}

    for (pat,num) in patterns.items():
        if num >= h:
            filtpatterns[pat]=num
        

    return filtpatterns


def printPatterns(patterns):
    
    for (pat,num) in patterns.items():        
        print pat + "\t" + str(num)

    

def frequentPatterns(filename,kmin,kmax,freq):

    prots = loadFasta(filename)

    for k in range(kmin,kmax+1):
        patterns=findPatterns(prots, k)
        patterns=filterPatterns(patterns,freq)
        printPatterns(patterns)
